/*
q3unban plugin for proxocket
by Luigi Auriemma
e-mail: aluigi@autistici.org
web:    aluigi.org
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "q3huff.h"

#ifdef WIN32
    #include <windows.h>

    BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpReserved) {
        switch(fdwReason) {
            case DLL_PROCESS_ATTACH: DisableThreadLibraryCalls(hinstDLL); break;
            default: break;
        }
        return(TRUE);
    }
#else
    #error this is a plugin for Proxocket which works only on Windows
#endif

typedef unsigned char u8;



#define VER                 "q3unban plugin for proxocket 0.1"
#define MAX_INFO_STRING     1024



int mysendto(SOCKET s, u_char **retbuf, int datalen, int flags, const struct sockaddr *to, int tolen) {
    int     diff,
            compress  = 1,
            connectsz = 12;
    u8      *data     = *retbuf,
            *connect,
            *p;

    if(datalen < 12) return(datalen);
    if(memcmp(data, "\xff\xff\xff\xff", 4)) return(datalen);
    if(memcmp(data + 4, "connect ", 8)) {
        if(memcmp(data + 4, "\x02" "connect ", 9)) return(datalen);
        connectsz = 13;
    }
    connect = data + connectsz;
    if(connect[0] == '\"') compress = 0;

    if(compress) datalen = Huff_DecompressPacket(data, connectsz, datalen, 0xffff);

    if(connect[0] == '\"') connect++;
    p = memchr(connect, '\"', datalen - (connect - data));
    if(!p) p = data + datalen;
    if((p - connect) < MAX_INFO_STRING) {
        memmove(connect + MAX_INFO_STRING, p, datalen - (p - data));
        diff = MAX_INFO_STRING - (p - connect);
        memset(p, 'A', diff);
        p[0]        = '\\';
        p[diff / 2] = '\\';
        datalen += diff;
        //printf("- q3unban activated\n");
    }

    if(compress) datalen = Huff_CompressPacket(data, connectsz, datalen);
    return(datalen);
}


